package com.sportradar.uf.odds;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import java.util.Scanner;
import java.util.stream.Collectors;
import org.apache.commons.io.IOUtils;

public class OddsUSConverterTest {

  private static List<Integer> ladder = new ArrayList<>();

  public static void main(String[] args) {
    try {
      IOUtils.readLines(
          OddsUSConverterTest.class.getResourceAsStream("/US Ladder - v2.csv"),
          StandardCharsets.UTF_8.name())
          .stream()
          .mapToInt(l -> Integer.parseInt((String) l))
          .forEach(ladder::add);
    } catch (IOException e) {
      System.err.println("Error reading ladder file:" + e.getMessage());
    }

    Scanner scanner = new Scanner(System.in);

    boolean quit = false;
    while (!quit) {
      System.out.println("Please enter decimal value, l to display the ladder, q to quit");
      String input = scanner.next();
      switch (input) {
        case "q":
          quit = true;
          break;
        case "l":
          System.out.println(
              ladder.stream().map(String::valueOf).collect(Collectors.joining(", ")));
          break;
        default:
          Double oddsEU = Double.parseDouble(input);
          Optional<Double> oddsUS = OddsUSConverterUtils.convertEuOddsToUs(oddsEU);
          if (oddsUS.isPresent()) {
            int oddsUSRounded = OddsUSConverterUtils.roundUSOdds(oddsUS.get(), ladder);
            System.out.println(
                "EU " + oddsEU + " => US " + oddsUS.get() + " => Rounded US " + oddsUSRounded);
          } else {
            System.out.println("EU " + oddsEU + " => can not be convert to US odds");
          }
      }
    }

    System.out.println("Goodbye");
    System.exit(0);
  }
}
