<?php
/**
 * Created by PhpStorm.
 * User: sebnoirot
 * Date: 27.06.18
 * Time: 11:01
 */

/**
 * @param float|int $oddsEu odds in EU format
 * @return float|int
 */
function convertEuOddsToUs($oddsEu)
{
  if ($oddsEu >= 2) {
    return ($oddsEu - 1) * 100;
  } else {
    return -100 / ($oddsEu - 1);
  }
}

/**
 * @param float|int $oddsUs odds in US format
 * @param array $ladder ladder
 * @return int rounded US odds
 */
function roundUSOdds($oddsUs, $ladder)
{
  $maxLadder = PHP_INT_MAX;
  $minLadder = PHP_INT_MIN;

  foreach ($ladder as $ladderValue) {
    if ($oddsUs >= $ladderValue) {
      $minLadder = $ladderValue;
    }
    if ($oddsUs <= $ladderValue && $ladderValue < $maxLadder) {
      $maxLadder = $ladderValue;
    }
  }
  return abs($oddsUs) - abs($minLadder) <= abs($maxLadder) - abs($oddsUs) ? $minLadder : $maxLadder;
}

echo "Welcome to odds convert!\n";

$file = fopen("US Ladder - v2.csv", "r");
$ladder = [];
while (!feof($file)) {
  $ladder[] = intval(fgets($file));
}
fclose($file);

do {
  echo 'Please enter decimal value, "l" to display the ladder, "q" to quit > ';
  $input = trim(str_replace(',', '.', fgets(STDIN)));
  if ($input == "l") {
    echo join(",", $ladder) . "\n";
  } elseif ($input == "q") {
    // quit
  } elseif (is_numeric($input) && $input >= 1) {
    $odds_us = convertEuOddsToUs($input);
    $odds_us_rounded = roundUSOdds($odds_us, $ladder);
    echo 'EU ' . $input . ' => US ' . $odds_us . ' => Rounded US ' . $odds_us_rounded . "\n";
  } else {
    echo "Wrong value\n";
  }
} while ($input !== "q");
echo "Goodbye\n";
