import sys
from decimal import Decimal

def convertEuOddsToUs(odds_eu):
    if odds_eu == 1:
        return None
    elif odds_eu >= 2:
        return (odds_eu - 1) * 100
    else:
        return (-100) / (odds_eu - 1)


def roundUSOdds(odds_us, ladder):
    max_ladder = sys.maxsize
    min_ladder = -max_ladder - 1

    for l in ladder:
        if odds_us >= l:
            min_ladder = l
        if odds_us <= l < max_ladder:
            max_ladder = l

    if abs(odds_us) - abs(min_ladder) <= abs(max_ladder) - abs(odds_us):
        return min_ladder
    else:
        return max_ladder


print("Welcome to odds convert!")

ladder = [int(line.rstrip('\n')) for line in open('US Ladder - v2.csv')]

while True:
    input_var = input("Please enter decimal value, l to display the ladder, q to quit\n")
    if input_var == "q":
        print("Goodbye")
        break
    elif input_var == "l":
        print(",".join(map(str, ladder)))
    else:
        oddsEu = Decimal(input_var)
        oddsUS = convertEuOddsToUs(oddsEu)
        if oddsUS is None:
            print("EU " + str(oddsEu) + " => can not be convert to US odds")
        else:
            oddsUSRounded = roundUSOdds(oddsUS, ladder)
            print("EU "
                  + str(oddsEu)
                  + " => US "
                  + str(float(oddsUS))
                  + " => Rounded US "
                  + str(oddsUSRounded))

